%define KVER 2.6.17-1.2299_FC6

Summary: Header files for the Linux kernel for use by glibc
Name: glibc-kernheaders
Version: 3.0
Release: 45.3
License: GPL
Group: Development/System
ExclusiveOS: Linux
Obsoletes: kernel-headers
Provides: kernel-headers = %{KVER}
Prereq: fileutils initscripts >= 5.83
BuildRequires: unifdef
%undefine _enable_debug_packages

BuildRoot: %{_tmppath}/glibc-kernheaders-root

%ifarch i386 i586 i686 athlon
%define _arch i386
%endif

Source0: glibc-kernheaders-%{KVER}.tar.bz2

%description
Kernel-headers includes the C header files that specify the interface
between the Linux kernel and userspace libraries and programs.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
glibc package


%prep
%setup -q -c

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
tar -cf -  usr | tar -xf - -C $RPM_BUILD_ROOT
pushd $RPM_BUILD_ROOT/usr/include
%define keepdirs asm-generic
%define asmdir asm-%{_target_cpu}

%ifarch x86_64
%define keepdirs asm-i386|asm-x86_64|asm-generic
%define asmdir asm-bix86
%endif
%ifarch ppc ppc64
%define asmdir asm-powerpc
%endif
%ifarch s390x
%define asmdir asm-s390
%endif
%ifarch sparc sparc64
%define asmdir asm-bisparc
%define keepdirs asm-sparc*|asm-generic
%endif

mv %{asmdir} asm
for DIR in asm-* ; do 
    case $DIR in
       %{keepdirs})
	    ;;
	*)
	    rm -rf $DIR
	    ;;
    esac
done
rm asm*/atomic.h
echo "#error asm/atomic.h is a kernel-private header. Even if your broken program compiled before, it was not likely to _work_." > asm/atomic.h

( echo "#ifdef I_AM_BROKEN_AND_I_KNOW_IT" 
  echo "#warning asm/io.h is a kernel-private header. Do not use it in userspace."
  echo "#else" 
  echo "#error asm/io.h is a kernel-private header. Do not use it in userspace."
  echo "#endif"
  cat asm/io.h ) > tmpfile

mv tmpfile asm/io.h
# glibc-headers provides /usr/include/scsi, although it's kernel headers
rm -rf scsi

popd

%clean
rm -rf $RPM_BUILD_ROOT


%pre
[ -L /usr/include/linux ] && rm -f /usr/include/linux || :
[ -L /usr/include/asm ] && rm -f /usr/include/asm || :
%ifarch sparc
[ -L /usr/include/asm-sparc ] && rm -f /usr/include/asm-sparc
[ -L /usr/include/asm-sparc64 ] && rm -f /usr/include/asm-sparc64
%endif
exit 0

%post
exit 0

###
### file lists
###

%files
%defattr(-,root,root)
/usr/include/*

%changelog
* Wed Jul 12 2006 David Woodhouse <dwmw2@redhat.com> 3.0-45.3
- Un-neuter it for now, till the mass rebuild is over

* Wed Jul 12 2006 David Woodhouse <dwmw2@redhat.com> 3.0-45.2
- Neuter package until it's killed off properly.

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> 3.0-45.1
- rebuild

* Tue Jun 20 2006 David Woodhouse <dwmw2@redhat.com> 3.0-45
- 2.6.17-1.2299_FC6 (-git3, drop i2c-id.h and i2c-algo-ite.h)

* Tue Jun 20 2006 David Woodhouse <dwmw2@redhat.com> 3.0-44
- Argh. Fscking brew.

* Tue Jun 20 2006 David Woodhouse <dwmw2@redhat.com> 3.0-43
- 2.6.17
- Update SPARC headers according to DaveM's list, add Alpha

* Wed Jun 14 2006 David Woodhouse <dwmw2@redhat.com> 3.0-42
- Update to 2.6.16-1.2282_FC6; fix asm-s390/posix_types.h (was #194891)

* Tue Jun 13 2006 David Woodhouse <dwmw2@redhat.com> 3.0-41
- Update to 2.6.16-1.2271_FC6; add new IPv6 netfilter headers (#121257)

* Mon Jun 12 2006 David Woodhouse <dwmw2@redhat.com> 3.0-40
- Update to 2.6.16-1.2266_FC6, remove compiler.h sed magic

* Fri Jun  9 2006 David Woodhouse <dwmw2@redhat.com> 3.0-39
- Bump release to 39 to retry build

* Fri Jun  9 2006 David Woodhouse <dwmw2@redhat.com> 3.0-38
- Update to 2.6.16-1.2260_FC6:
- Add GFS2, DLM headers
- Allow building for SPARC and Alpha if they're present

* Wed May 24 2006 David Woodhouse <dwmw2@redhat.com> 3.0-37
- Update to 2.6.16-1.2240_FC6:
- Remove <asm-s390/sfp-machine.h> at Martin's request
- Include <sys/types.h> from <linux/input.h> (#193747)

* Wed May 24 2006 David Woodhouse <dwmw2@redhat.com> 3.0-36
- Update to 2.6.16-1.2211_FC6:
- sync_file_range() flags in <linux/fs.h>
- sys_[gs]et_robust_range syscalls in <asm-powerpc/unistd.h>
  
* Sun May 21 2006 David Woodhouse <dwmw2@redhat.com> 3.0-35
- Fix asm-x86_64/mtrr.h to not attempt to include <linux/compat.h>

* Thu May 18 2006 David Woodhouse <dwmw2@redhat.com> 3.0-34
- Add fdreg.h (#191954)

* Wed May 17 2006 David Woodhouse <dwmw2@redhat.com> 3.0-33
- Add in_route.h (#192012)

* Tue May 16 2006 David Woodhouse <dwmw2@redhat.com> 3.0-32
- Remove struct fddi_statistics from if_fdds.h (#192006)

* Tue May 16 2006 David Woodhouse <dwmw2@redhat.com> 3.0-31
- Update from 2.6.17-rc4. New S390 syscalls. 
- Add <linux/hayesesp.h> (#191883)

* Wed May 10 2006 David Woodhouse <dwmw2@redhat.com> 3.0-30
- Add asm-s390/z90crypt.h
- Add linux/usbdevice_fs.h, linux/usb_ch9.h

* Sun May  7 2006 David Woodhouse <dwmw2@redhat.com> 3.0-29
- Remove asm/semaphore.h, asm/mmu.h
- Replace asm/atomic.h with a simple #error
- Add #warning to asm/io.h

* Sat May  6 2006 David Woodhouse <dwmw2@redhat.com> 3.0-28
- Remove include/media/ since Mauro says we don't need it

* Sat May  6 2006 David Woodhouse <dwmw2@redhat.com> 3.0-27
- Fix up '(__force...' etc too.

* Sat May  6 2006 David Woodhouse <dwmw2@redhat.com> 3.0-26
- Use sed to remove __user, __iomem, __force, __attribute_const__
- Change all 'inline' to '__inline__'

* Sat May  6 2006 David Woodhouse <dwmw2@redhat.com> 3.0-25
- Update from 2.6.17-rc3. More cleanups, new syscalls on PPC

* Tue May  2 2006 David Woodhouse <dwmw2@redhat.com> 3.0-24
- ... but not quite that much. Put __attribute_const__ back for now.

* Tue May  2 2006 David Woodhouse <dwmw2@redhat.com> 3.0-23
- Clean up linux/compiler.h

* Sat Apr 29 2006 David Woodhouse <dwmw2@redhat.com> 3.0-22
- Add linux/pci.h

* Fri Apr 28 2006 David Woodhouse <dwmw2@redhat.com> 3.0-21
- Remove the libaudit workaround hack

* Fri Apr 28 2006 David Woodhouse <dwmw2@redhat.com> 3.0-20
- Remove syscall macros from asm-*/unistd.h
- Clean up asm-generic/signal.h
- Update kernel-headers Provides:

* Thu Apr 27 2006 David Woodhouse <dwmw2@redhat.com> 3.0-19
- Remove device table crap from linux/input.h (#190157)

* Thu Apr 27 2006 David Woodhouse <dwmw2@redhat.com> 3.0-18
- Remove 'extern int errno;' from linux/unistd.h

* Thu Apr 27 2006 David Woodhouse <dwmw2@redhat.com> 3.0-17
- Fix mii.h, ethtool.h, version.h, blkpg.h

* Thu Apr 27 2006 David Woodhouse <dwmw2@redhat.com> 3.0-16
- ...this time with the right tarball so it's actually changed

* Thu Apr 27 2006 David Woodhouse <dwmw2@redhat.com> 3.0-15
- Fix asm-i386/page.h and asm-x86_64/page.h for Xen

* Thu Apr 27 2006 David Woodhouse <dwmw2@redhat.com> 3.0-14
- Fix asm/s390/{ptrace.h,page.h}

* Thu Apr 27 2006 David Woodhouse <dwmw2@redhat.com> 3.0-13
- Work around libaudit.h defining audit_rule_data

* Thu Apr 27 2006 David Woodhouse <dwmw2@redhat.com> 3.0-12
- ... and remove the inclusion of <linux/config.h> from it.

* Thu Apr 27 2006 David Woodhouse <dwmw2@redhat.com> 3.0-11
- Include asm-ia64/*intrin*.h

* Wed Apr 26 2006 David Woodhouse <dwmw2@redhat.com> 3.0-10
- Change the include guards for biarch headers to cope with -undef

* Wed Apr 26 2006 David Woodhouse <dwmw2@redhat.com> 3.0-9
- Add asm-generic/ioctl.h

* Wed Apr 26 2006 David Woodhouse <dwmw2@redhat.com> 3.0-8
- Updated tarball from 'make headers_install' from 2.6.16-1.2166_FC6
  This should match the contents of the 'kernel-headers' subpackage
  of the kernel, if I was brave enough to actually switch over to that
  for real. Let's just test it this way for now though...

* Mon Apr 24 2006 Jakub Jelinek <jakub@redhat.com> - 3.0-7
- fix typo in the i386 fstatat64 change
- Add new syscalls up to 2006-04-24

* Fri Apr 07 2006 David Woodhouse <dwmw2@redhat.com> - 3.0-6
- Fix fstatat64 on i386 (it's not newfstatat)

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 3.0-5.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 3.0-5.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Mon Feb 6 2006 David Woodhouse <dwmw2@redhat.com> 3.0-5
- Add EOWNERDEAD and ENOTRECOVERABLE error codes

* Tue Jan 24 2006 David Woodhouse <dwmw2@redhat.com> 3.0-4
- Add pselect/ppoll on x86_64

* Fri Jan 20 2006 David Woodhouse <dwmw2@redhat.com> 3.0-3
- Add new syscalls up to 2006-01-20

* Tue Oct 25 2005 David Woodhouse <dwmw2@redhat.com> 3.0-2
- Fix order of version and ihl in struct iphdr. (#171678)

* Mon Jun 13 2005 David Woodhouse <dwmw2@redhat.com> 3.0-1
- Add WDIOC_GETTIMEOUT, WDIOC_SETTIMEOUT to watchdog.h (#155653)
- Update version number to make it not look confusingly like a kernel version

* Mon May 23 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.95
- Update audit.h, add CAP_AUDIT_{WRITE,CONTROL} to capability.h

* Sun Apr 17 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.94
- Remove __user from videodev, dvb headers (#155157)

* Fri Apr 15 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.93
- Restore version.h to 2.4.20. Yeah, stuff which depends on it is broken,
  but let's not rub it in their faces till after FC4 is out.

* Fri Apr 15 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.92
- Fix PT_FPSCR definition on PPC64 (#91727)
- Move PPC_PTRACE_xxx_3264 from ppc64 to ppc32 ptrace.h (#97641)
- Support VMX in ptrace.h on ppc/ppc64 (#146727)
- Fix ppc64 stat.h, statfs.h (#146909, #146914)
- Update ia64 ptrace_offsets.h (#117234)
- Add IPV6_V6ONLY to in6.h (#97088)
- Update cosmetic version in linux/version.h (#117020)
- Include videodev2.h (#122671)
- Drop contents of quota.h. Just bitch and include sys/quota.h instead.
- Fix socket.h definitions to add SO_PEERSEC, AF_LLC, etc. (#134444)
- Add x86_64 mce.h (#137974)
- Provide linux/futex.h (#138823)
- The GPL has more than one term (#139184)
- Fix duplicate definition of __NR_epoll_{ctl,wait} on x86_64 (#139586)
- Include uinput.h (#142812)
- Include if_infiniband.h (#147590)
- Add SHM_EXEC to shm.h (#150602)
- Add DVB headers (#154493)
- Add keyctl.h and new errno values (#154567)
- Add missing waitid and keyctl syscalls to */unistd.h (#154567,#140951)

* Wed Feb 23 2005 David Woodhouse <dwmw2@redhat.com> 2.4.9-1.90
- Add linux/audit.h (#139935)

* Thu Jan 20 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.89
- Revert the tarball update of December 10th; too much was pruned.

* Tue Jan 18 2005 David Woodhouse <dwmw2@redhat.com> 2.4-9.1.88
- Fix and update and include missing ATM headers (#127098)
- Update MTD headers.

* Fri Dec 10 2004 Roland McGrath <roland@redhat.com>
- update syscall numbers on x86_64, ia64
- removed many files users should not need
- update ia64 ptrace_offsets.h (#117234)
- other misc updates from upstream

* Tue Aug 31 2004 Arjan van de Ven <arjanv@redhat.com> 2.4-9.1.87
- update input.h

* Thu Jul 29 2004 Arjan van de Ven <arjanv@redhat.com>
- update limits.h to reflect NR_GROUPS change

* Thu Jul 22 2004 Jakub Jelinek <jakub@redhat.com>
- update syscall numbers from latest kernel on alpha/ia64

* Fri Jun 25 2004 Arjan van de Ven <arjanv@redhat.com>
- fix mtrr header for x86_64

* Wed Apr 21 2004 Jakub Jelinek <jakub@redhat.com> 2.4-8.46
- ppc/ppc64 mq_* syscall numbers

* Fri Apr 16 2004 Jakub Jelinek <jakub@redhat.com> 2.4-8.45
- update syscall numbers from latest kernel
- remove ia32.h and ia32_unistd.h on x86-64

* Mon Mar 15 2004 Bill Nottingham <notting@redhat.com> 2.4-8.44
- update wireless.h

* Tue Dec 09 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.38
- remove a lot of kernel-only crud

* Tue Dec  2 2003 Jeremy Katz <katzj@redhat.com> 2.4-8.37
- add BLKGETSIZE64

* Wed Oct 22 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.35
- fix broken shift_hz
* Wed Sep 24 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.34
- fix ppc64 sigcontext.h (#104915)

* Mon Sep  8 2003 Bill Nottingham <notting@redhat.com>
- oops, bring arp_tables.h back

* Wed Sep  3 2003 Bill Nottingham <notting@redhat.com>
- remove some exports of __constant_hton*

* Sat Aug 23 2003 Arjan van de Ven <arjanv@redhat.com>
- fix typo in netdevice.h as per #102951

* Thu Aug 21 2003 Arjan van de Ven <arjanv@redhat.com>
- update personality.h for the amd64 3Gb 32 bit personality

* Tue Aug 19 2003 Arjan van de Ven <arjanv@redhat.com>
- add asm/types.h to a few .h files that need it
- remove unistd.h from linux/limits.h; it breaks samba builds

* Tue Aug 19 2003 Doug Ledford <dledford@redhat.com>
- Add updated prctl.h file that includes process timing defines

* Sat Aug 16 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.27
- add tgkill to unistd.h on ppc64, x86_64 and alpha

* Thu Jul 31 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.26
- update ia64/sigcontext.h from 2.5.73+ (#101344)

* Wed Jul 30 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.25
- make ppc64/uaccess.h match the upstream ABI

* Mon Jul 28 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.24
- rebuilt

* Mon Jul 28 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.23
- add tgkill to unistd.h on i386, ia64 and ppc32
- remove __KERNEL_SYSCALLS__ cruft on ia64/ppc32

* Mon Jul 14 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.22
- add arptables headers

* Fri Jun 27 2003 Arjan van de Ven <arjanv@redhat.com> 2.4.8.20
- update ptrace headers for amd64

* Wed Jun 18 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.19
- update for new bonding interface

* Fri Jun 06 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.18
- change syscall stubs to use the glibc ones

* Thu Jun  5 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.17
- rebuilt

* Mon Jun  2 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.16
- add new scsi majors to <linux/major.h> (#91696)

* Fri May 30 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.15
- add amd64 nptl syscalls

* Tue May 27 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.14
- unifdef'd a bunch of header files for __KERNEL__

* Sun Apr 13 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.13
- remove more kernel private files

* Fri Apr 11 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.12
- update <linux/prctl.h> header
- remove i386 <asm/io.h>, replace it with a warning and <sys/io.h> include
  (Arjan van de Ven)

* Mon Feb 10 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.11
- update syscall numbers for all arches from 2.5.64 headers

* Fri Feb  7 2003 Bill Nottingham <notting@redhat.com> 2.4-8.10
- update more wireless headers

* Wed Feb  5 2003 Bill Nottingham <notting@redhat.com> 2.4-8.9
- update wireless headers

* Thu Jan 30 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.7
- make /usr/include/asm during build if it doesn't exist

* Thu Jan 30 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.6
- remove unpackaged file

* Thu Jan 30 2003 Bill Nottingham <notting@redhat.com>
- update netfilter headers

* Thu Jan 30 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.5
- don't include <linux/types.h> etc. in <asm-s390*/ptrace.h>

* Thu Jan 16 2003 Jakub Jelinek <jakub@redhat.com> 2.4-8.4
- updated s390 headers, added s390x headers
- HTB in <linux/pkt_sched.h>
- no -debuginfo subpackage

* Thu Dec 12 2002 Jakub Jelinek <jakub@redhat.com> 2.4-8.3
- update version.h from kernel-2.4.20-0.pp.6

* Tue Nov 26 2002 Jakub Jelinek <jakub@redhat.com> 2.4-8.2
- update unistd.h from kernel-2.4.19-0.pp.19

* Thu Oct 10 2002 Jakub Jelinek <jakub@redhat.com>
- generate stubs automatically
- remove /usr/include/scsi from file list

* Thu Oct 10 2002 Arjan van de Ven <arjanv@redhat.com
- added support for mixed 32/64 headers

* Tue Mar 21 2002 Arjan van de Ven <arjanv@redhat.com
- update ethtool and other network ioctls

* Tue Feb 10 2002 Arjan van de Ven <arjanv@redhat.com
- removed autoconf.h content

* Sun Feb 10 2002 Arjan van de Ven <arjanv@redhat.com
- fix missing include that broke quota.h

* Mon Jan 07 2002 Arjan van de Ven <arjanv@redhat.com
- fix rhconfig.h include file to not care about /boot/kernel.h

* Wed Jan 02 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- fix #warning in <asm-i386/rwlock.h> and <asm-i386/spinlock.h>

* Thu Dec 6 2001 Arjan van de Ven <arjanv@redhat.com>
- fix misplaced #endif

* Tue Dec 4 2001 Arjan van de Ven <arjanv@redhat.com>
- fix version.h to not include /boot/kernel.h

* Wed Oct 31 2001 Arjan van de Ven <arjanv@redhat.com>
- Initial packaging
